local importPath=string.gsub(getfenv(1)._.Name,"%.Icon","").."."

icon = Turbine.UI.Window()
icon.resourcePath=string.gsub(importPath,"%.","/").."Resources/"
-- replace with an appropriate image
icon:SetSize(32,32);
icon.UpImage=icon.resourcePath.."map_up.jpg"
icon.DragImage=icon.resourcePath.."map_drag.jpg"
icon.HoverImage=icon.resourcePath.."map_down.jpg"
icon.DefaultOpacity=.3;

local left=1;
local top=Turbine.UI.Display.GetHeight()-icon:GetHeight()-1;
if (Settings~=nil) then
	if Settings.IconTopPercent~=nil then
		Settings.IconTopPercent=euroNormalize(Settings.IconTopPercent)
	end
	if Settings.IconLeftPercent~=nil then
		Settings.IconLeftPercent=euroNormalize(Settings.IconLeftPercent)
	end

	if Settings.UseMiniIcon~=nil and Settings.UseMiniIcon then
		icon.UpImage=icon.resourcePath.."mini_icon.tga";
		icon.DragImage=icon.resourcePath.."mini_icon.tga";
		icon.HoverImage=icon.resourcePath.."mini_hover.tga";
	end
end
if Settings==nil then
	Settings={}
end
if Settings.IconTopPercent==nil then
	Settings.IconTopPercent=0
end
if Settings.IconLeftPercent==nil then
	Settings.IconLeftPercent=0
end
if Settings.UseMiniIcon==nil then
	Settings.UseMiniIcon=false
end
if Settings.MiniIconOpaque==nil then
	Settings.MiniIconOpaque=true
end
if Settings.LoadMinimized==nil then
	Settings.LoadMinimized=false
end

icon:SetBackground(icon.UpImage);
if Settings.UseMiniIcon then
	icon:SetSize(16,16);
end
if Settings.UseMiniIcon and Settings.MiniIconOpaque then
	icon.DefaultOpacity=1;
else
	icon.DefaultOpacity=.3;
end
icon:SetOpacity(icon.DefaultOpacity);
icon:SetPosition( Settings.IconLeftPercent/100*displayWidth, Settings.IconTopPercent/100*displayHeight );
icon:SetZOrder(icon:GetZOrder()+1);
icon.MouseClick = function(sender,args)
	icon:SetBackground(icon.UpImage);
	if icon.Moving then
		icon.Moving=false;
		icon.MoveX=-1;
	else
		icon:SetVisible(false);
		mapWindow:SetVisible(true);
	end
end

icon.MoveX=-1;
icon.MoveY=0;
icon.Moving=false;

icon.MouseDown=function(sender,args)
	if icon:IsAltKeyDown() or icon:IsControlKeyDown() then
		icon:SetBackground(icon.HoverImage);
		icon.MoveX=args.X;
		icon.MoveY=args.Y;
	end
end
icon.MouseUp=function(sender,args)
	icon:SetBackground(icon.UpImage);
	icon.MoveX=-1;
	icon.MoveY=0;
end

icon.MouseEnter=function(sender,args)
	icon:SetOpacity(1);
end

icon.MouseLeave=function(sender,args)
	icon:SetOpacity(icon.DefaultOpacity);
end

icon.MouseMove=function(sender,args)
	if icon.MoveX~=-1 and (args.X~=icon.MoveX or args.Y~= icon.MoveY) then
		icon:SetBackground(icon.DragImage);
		icon.Moving=true;
		local newLeft=icon:GetLeft()-(icon.MoveX-args.X)
		local newTop=icon:GetTop()-(icon.MoveY-args.Y)
		if newLeft<0 then newLeft=0 end;
		if newLeft>(Turbine.UI.Display.GetWidth()-icon:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-icon:GetWidth() end;
		if newTop<0 then newTop=0 end;
		if newTop>(Turbine.UI.Display.GetHeight()-icon:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-icon:GetHeight() end;
		icon:SetPosition(newLeft,newTop);
	end
end

icon.Update=function(sender,args)
	icon.SetWantsUpdates(false); -- turn updates off... no need to waste machine cycles on this
end
icon.SetUseMiniIcon=function(sender,value)
	Settings.UseMiniIcon=value;
	if value==true then
		icon.UpImage=icon.resourcePath.."mini_icon.tga";
		icon.DragImage=icon.resourcePath.."mini_icon.tga";
		icon.HoverImage=icon.resourcePath.."mini_hover.tga";
	else
		icon.UpImage=icon.resourcePath.."map_up.jpg"
		icon.DragImage=icon.resourcePath.."map_drag.jpg"
		icon.HoverImage=icon.resourcePath.."map_down.jpg"
	end
	if Settings.UseMiniIcon and Settings.MiniIconOpaque then
		icon.DefaultOpacity=1;
	else
		icon.DefaultOpacity=.3;
	end
	icon:SetOpacity(icon.DefaultOpacity);
	icon:SetBackground(icon.UpImage);
	if Settings.UseMiniIcon then
		icon:SetSize(16,16);
	else
		icon:SetSize(32,32);
	end
end
icon.SetMiniIconOpaque=function(sender,value)
	Settings.MiniIconOpaque=value;
	if Settings.UseMiniIcon and Settings.MiniIconOpaque then
		icon.DefaultOpacity=1;
	else
		icon.DefaultOpacity=.3;
	end
	icon:SetOpacity(icon.DefaultOpacity);
end
icon:SetVisible(Settings.LoadMinimized and Settings.ShowIcon);
