--***********************************************************************************************************************************
--                                                          pending annotations window
-- this window displays the list of received annotations that are not duplicates and not on the Black List
--***********************************************************************************************************************************
-- pending annotations window...
PendingWindow=Turbine.UI.Lotro.Window()
PendingWindow:SetVisible(false)
PendingWindow:SetSize(1000,500)
PendingWindow:SetPosition((displayWidth-PendingWindow:GetWidth())/2,(displayHeight-PendingWindow:GetHeight())/2)
PendingWindow:SetText(Resource[language][84])

PendingWindow.CommandRow=Turbine.UI.Control()
PendingWindow.CommandRow:SetParent(PendingWindow)
PendingWindow.CommandRow:SetSize(PendingWindow:GetWidth()-10,22)
PendingWindow.CommandRow:SetPosition(5,45)
PendingWindow.CommandRow:SetBackColor(Turbine.UI.Color.Grey)
PendingWindow.CommandBack=Turbine.UI.Control()
PendingWindow.CommandBack:SetParent(PendingWindow.CommandRow)
PendingWindow.CommandBack:SetSize(PendingWindow.CommandRow:GetWidth()-2,PendingWindow.CommandRow:GetHeight()-2)
PendingWindow.CommandBack:SetPosition(1,1)
PendingWindow.CommandBack:SetBackColor(Turbine.UI.Color.Black)

PendingWindow.Accept=Turbine.UI.Lotro.Button()
PendingWindow.Accept:SetParent(PendingWindow.CommandBack)
PendingWindow.Accept:SetSize(120,20)
PendingWindow.Accept:SetPosition(20,0)
PendingWindow.Accept:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.Accept:SetText(Resource[language][85])
PendingWindow.Accept.Click=function()
	local index=1
	-- detect if MoorMap is loaded and unload it
	local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
	for pluginIndex=1,#tmpPlugins do
		if tmpPlugins[pluginIndex].Name=="MoorMap" then
			mapWindow.ReloadMoorMap=true;
			break;
		end
	end
	if mapWindow.ReloadMoorMap then
		pcall(Turbine.PluginManager.UnloadScriptState,"MoorMap")
	end
	while index<=PendingWindow.List:GetItemCount() do
		local item=PendingWindow.List:GetItem(index)
		if item.Check:IsChecked() then
			item.Check:SetChecked(false)
			local name=item.Source:GetText()
			mapWindow.AddBatchAnnotation(item.region, item.ns, item.ew, item.type, item.Name:GetText(), item.Desc:GetText())
			PendingWindow.List:RemoveItemAt(index)
		else
			index=index+1
		end
	end
	if PendingWindow.List:GetItemCount()==0 then
		mapWindow.Pending:SetVisible(false)
	end
	-- commands were already created by AddBatchAnnotation, just need to trigger TMCust now
	mapWindow.Pending:SetWantsUpdates(true)
	Turbine.PluginManager.LoadPlugin("TMCust")
end
PendingWindow.WhiteList=Turbine.UI.Lotro.Button()
PendingWindow.WhiteList:SetParent(PendingWindow.CommandBack)
PendingWindow.WhiteList:SetSize(120,20)
PendingWindow.WhiteList:SetPosition(PendingWindow.Accept:GetLeft()+PendingWindow.Accept:GetWidth()+10,0)
PendingWindow.WhiteList:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.WhiteList:SetText(Resource[language][86])
PendingWindow.WhiteList.Click=function()
	local index=1
	local launchTMCust=false
	while index<=PendingWindow.List:GetItemCount() do
		local item=PendingWindow.List:GetItem(index)
		if item.Check:IsChecked() then
			item.Check:SetChecked(false)
			local name=item.Source:GetText()
			launchTMCust=(launchTMCust or WhiteListAddNew(name))
		else
			index=index+1
		end
	end
	if PendingWindow.List:GetItemCount()==0 then
		mapWindow.Pending:SetVisible(false)
	end
	if launchTMCust then
		-- detect if MoorMap is loaded and unload it
		local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
		for pluginIndex=1,#tmpPlugins do
			if tmpPlugins[pluginIndex].Name=="MoorMap" then
				mapWindow.ReloadMoorMap=true;
				break;
			end
		end
		if mapWindow.ReloadMoorMap then
			pcall(Turbine.PluginManager.UnloadScriptState,"MoorMap")
		end
		mapWindow.Pending:SetWantsUpdates(true)
		Turbine.PluginManager.LoadPlugin("TMCust")
	end
end

PendingWindow.BlackList=Turbine.UI.Lotro.Button()
PendingWindow.BlackList:SetParent(PendingWindow.CommandBack)
PendingWindow.BlackList:SetSize(120,20)
PendingWindow.BlackList:SetPosition(PendingWindow.WhiteList:GetLeft()+PendingWindow.WhiteList:GetWidth()+10,0)
PendingWindow.BlackList:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.BlackList:SetText(Resource[language][87])
PendingWindow.BlackList.Click=function()
	local index=1
	while index<=PendingWindow.List:GetItemCount() do
		local item=PendingWindow.List:GetItem(index)
		if item.Check:IsChecked() then
			item.Check:SetChecked(false)
			local name=item.Source:GetText()
			BlackListAddNew(name,true)
		else
			index=index+1
		end
	end
	if PendingWindow.List:GetItemCount()==0 then
		mapWindow.Pending:SetVisible(false)
	end
end

PendingWindow.Remove=Turbine.UI.Lotro.Button()
PendingWindow.Remove:SetParent(PendingWindow.CommandBack)
PendingWindow.Remove:SetSize(120,20)
PendingWindow.Remove:SetPosition(PendingWindow.BlackList:GetLeft()+PendingWindow.BlackList:GetWidth()+10,0)
PendingWindow.Remove:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.Remove:SetText(Resource[language][89])
PendingWindow.Remove.Click=function(sender,args)
	-- just remove all checked entries
	local index=1
	while index<=PendingWindow.List:GetItemCount() do
		local item=PendingWindow.List:GetItem(index)
		if item.Check:IsChecked() then
			PendingWindow.List:RemoveItemAt(index)
		else
			index=index+1
		end
	end
	if PendingWindow.List:GetItemCount()==0 then
		mapWindow.Pending:SetVisible(false)
	end
end
PendingWindow.Note=Turbine.UI.Label()
PendingWindow.Note:SetParent(PendingWindow.CommandBack)
PendingWindow.Note:SetPosition(PendingWindow.Remove:GetLeft()+PendingWindow.Remove:GetWidth()+5,0)
PendingWindow.Note:SetSize(PendingWindow.CommandBack:GetWidth()-PendingWindow.Note:GetLeft()-5,20)
PendingWindow.Note:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.Note:SetText("Commands applied to selected items.")
PendingWindow.Table=Turbine.UI.Control()
PendingWindow.Table:SetParent(PendingWindow)
PendingWindow.Table:SetPosition(PendingWindow.CommandRow:GetLeft(),PendingWindow.CommandRow:GetTop()+PendingWindow.CommandRow:GetHeight()+5)
PendingWindow.Table:SetBackColor(Turbine.UI.Color.Grey)
PendingWindow.Table:SetSize(PendingWindow.CommandRow:GetWidth(),PendingWindow:GetHeight()-PendingWindow.Table:GetTop()-40)

PendingWindow.Header=Turbine.UI.Control()
PendingWindow.Header:SetParent(PendingWindow.Table)
PendingWindow.Header:SetSize(PendingWindow.Table:GetWidth()-12,22)
PendingWindow.Header:SetBackColor(Turbine.UI.Color.Gold)
PendingWindow.XLabel=Turbine.UI.Label()
PendingWindow.XLabel:SetParent(PendingWindow.Header)
PendingWindow.XLabel:SetSize(20,20)
PendingWindow.XLabel:SetPosition(1,1)
PendingWindow.XLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.XLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.XLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.XLabel:SetText("X")

PendingWindow.SourceLabel=Turbine.UI.Label()
PendingWindow.SourceLabel:SetParent(PendingWindow.Header)
PendingWindow.SourceLabel:SetSize(120,20)
PendingWindow.SourceLabel:SetPosition(22,1)
PendingWindow.SourceLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.SourceLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.SourceLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.SourceLabel:SetText(Resource[language][88])

PendingWindow.RegionLabel=Turbine.UI.Label()
PendingWindow.RegionLabel:SetParent(PendingWindow.Header)
PendingWindow.RegionLabel:SetSize(120,20)
PendingWindow.RegionLabel:SetPosition(143,1)
PendingWindow.RegionLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.RegionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.RegionLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.RegionLabel:SetText(Resource[language][66])

PendingWindow.NSLabel=Turbine.UI.Label()
PendingWindow.NSLabel:SetParent(PendingWindow.Header)
PendingWindow.NSLabel:SetSize(80,20)
PendingWindow.NSLabel:SetPosition(264,1)
PendingWindow.NSLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.NSLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.NSLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.NSLabel:SetText(Resource[language][67])

PendingWindow.EWLabel=Turbine.UI.Label()
PendingWindow.EWLabel:SetParent(PendingWindow.Header)
PendingWindow.EWLabel:SetSize(80,20)
PendingWindow.EWLabel:SetPosition(345,1)
PendingWindow.EWLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.EWLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.EWLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.EWLabel:SetText(Resource[language][68])

PendingWindow.TypeLabel=Turbine.UI.Label()
PendingWindow.TypeLabel:SetParent(PendingWindow.Header)
PendingWindow.TypeLabel:SetSize(40,20)
PendingWindow.TypeLabel:SetPosition(426,1)
PendingWindow.TypeLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.TypeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.TypeLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.TypeLabel:SetText(Resource[language][65])

PendingWindow.NameLabel=Turbine.UI.Label()
PendingWindow.NameLabel:SetParent(PendingWindow.Header)
PendingWindow.NameLabel:SetSize(120,20)
PendingWindow.NameLabel:SetPosition(467,1)
PendingWindow.NameLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.NameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.NameLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.NameLabel:SetText(Resource[language][69])

PendingWindow.DescLabel=Turbine.UI.Label()
PendingWindow.DescLabel:SetParent(PendingWindow.Header)
PendingWindow.DescLabel:SetPosition(588,1)
PendingWindow.DescLabel:SetSize(PendingWindow.Header:GetWidth()-PendingWindow.DescLabel:GetLeft()-1,20)
PendingWindow.DescLabel:SetBackColor(Turbine.UI.Color.Black)
PendingWindow.DescLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
PendingWindow.DescLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
PendingWindow.DescLabel:SetText(Resource[language][70])

PendingWindow.List=Turbine.UI.ListBox()
PendingWindow.List:SetParent(PendingWindow.Table)
PendingWindow.List:SetPosition(0,PendingWindow.Header:GetTop()+PendingWindow.Header:GetHeight())
PendingWindow.List:SetSize(PendingWindow.Table:GetWidth()-12,PendingWindow.Table:GetHeight()-PendingWindow.List:GetTop()-1)
PendingWindow.List:SetBackColor(Turbine.UI.Color.Black)

PendingWindow.VScroll=Turbine.UI.Lotro.ScrollBar()
PendingWindow.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
PendingWindow.VScroll:SetParent(PendingWindow.Table)
PendingWindow.VScroll:SetBackColor(Turbine.UI.Color.DarkGrey)
PendingWindow.VScroll:SetWidth(10)
PendingWindow.VScroll:SetHeight(PendingWindow.List:GetHeight())
PendingWindow.VScroll:SetPosition(PendingWindow.List:GetLeft()+PendingWindow.List:GetWidth(),PendingWindow.List:GetTop())
PendingWindow.List:SetVerticalScrollBar(PendingWindow.VScroll)

-- populate from PendingAnnotations (loaded in Main)
PendingWindow.AddEntry=function(source,region,h,v,x,y,type,name,desc)
		local tmpNSEW
		tmpNSEW=GetNSEWfromHVXY(region,h,v,x,y)
		-- create a new row object for each annot, storing all of the relevant info in the row
		tmpRow=Turbine.UI.Control()
		tmpRow.h=h
		tmpRow.v=v
		tmpRow.x=x
		tmpRow.y=y
		tmpRow.ns=tmpNSEW.NS
		tmpRow.ew=tmpNSEW.EW
		tmpRow.region=region
		tmpRow.type=type
		tmpRow:SetBackColor(Turbine.UI.Color.Gold)
		tmpRow:SetParent(PendingWindow.List)
		tmpRow:SetSize(PendingWindow.List:GetWidth(),21)
		tmpRow.Check=Turbine.UI.Lotro.CheckBox()
		tmpRow.Check:SetParent(tmpRow)
		tmpRow.Check:SetSize(20,20)
		tmpRow.Check:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.Check:SetLeft(1)
		tmpRow.Source=Turbine.UI.Label()
		tmpRow.Source:SetParent(tmpRow)
		tmpRow.Source:SetSize(120,20)
		tmpRow.Source:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.Source:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
		tmpRow.Source:SetLeft(22)
		tmpRow.Source:SetText(source)
		tmpRow.Region=Turbine.UI.Label()
		tmpRow.Region:SetParent(tmpRow)
		tmpRow.Region:SetSize(120,20)
		tmpRow.Region:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.Region:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
		tmpRow.Region:SetLeft(143)
		if region==2 then
			tmpRow.Region:SetText(Resource[language][14])
		elseif region==3 then
			tmpRow.Region:SetText(Resource[language][24])
		elseif region==4 then
			tmpRow.Region:SetText(Resource[language][56])
		else
			tmpRow.Region:SetText(Resource[language][13])
		end
		tmpRow.NS=Turbine.UI.Label()
		tmpRow.NS:SetParent(tmpRow)
		tmpRow.NS:SetSize(80,20)
		tmpRow.NS:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.NS:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
		tmpRow.NS:SetLeft(264)
		if tmpNSEW.NS<0 then
			tmpRow.NS:SetText(tostring(0-tmpNSEW.NS).." S")
		else
			tmpRow.NS:SetText(tostring(tmpNSEW.NS).." N")
		end

		tmpRow.EW=Turbine.UI.Label()
		tmpRow.EW:SetParent(tmpRow)
		tmpRow.EW:SetSize(80,20)
		tmpRow.EW:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.EW:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
		tmpRow.EW:SetLeft(345)
		if tmpNSEW.EW<0 then
			tmpRow.EW:SetText(tostring(0-tmpNSEW.EW).." W")
		else
			tmpRow.EW:SetText(tostring(tmpNSEW.EW).." E")
		end
		
		tmpRow.IconBack=Turbine.UI.Control()
		tmpRow.IconBack:SetParent(tmpRow)
		tmpRow.IconBack:SetSize(40,20)
		tmpRow.IconBack:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.IconBack:SetLeft(426)
		tmpRow.Icon=Turbine.UI.Control()
		tmpRow.Icon:SetParent(tmpRow.IconBack)
		tmpRow.Icon:SetSize(16,16)
		tmpRow.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		tmpRow.Icon:SetBackground(annotIcon[type].icon)
		tmpRow.Icon:SetPosition(12,2)

		tmpRow.Name=Turbine.UI.Label()
		tmpRow.Name:SetParent(tmpRow)
		tmpRow.Name:SetSize(120,20)
		tmpRow.Name:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.Name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
		tmpRow.Name:SetLeft(467)
		tmpRow.Name:SetText(name)

		tmpRow.Desc=Turbine.UI.Label()
		tmpRow.Desc:SetParent(tmpRow)
		tmpRow.Desc:SetLeft(588)
		tmpRow.Desc:SetSize(tmpRow:GetWidth()-tmpRow.Desc:GetLeft()-1,20)
		tmpRow.Desc:SetBackColor(Turbine.UI.Color.Black)
		tmpRow.Desc:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
		tmpRow.Desc:SetMultiline(false)
		tmpRow.Desc:SetText(desc)

		PendingWindow.List:AddItem(tmpRow)
end
do
	for i,j in ipairs(PendingAnnotations) do
		PendingWindow.AddEntry(j.source,j.region,j.h,j.v,j.x,j.y,j.type,j.name,j.desc)
	end
end
PendingWindow.GetEntries=function()
	PendingAnnotations={}
	for k=1,PendingWindow.List:GetItemCount() do
		local row=PendingWindow.List:GetItem(k)
		local i=#PendingAnnotations+1
		PendingAnnotations[i]={}
		PendingAnnotations[i].source=row.Source:GetText()
		PendingAnnotations[i].region=row.region
		PendingAnnotations[i].h=row.h
		PendingAnnotations[i].v=row.v
		PendingAnnotations[i].x=row.x
		PendingAnnotations[i].y=row.y
		PendingAnnotations[i].type=row.type
		PendingAnnotations[i].name=row.Name:GetText()
		PendingAnnotations[i].desc=row.Desc:GetText()
	end
end
