-- uses the command "0TMP_NAME" to pass search parameter to the plugin which processes the search
-- the processing plugin will create a "0TMResult_H_V_X_Y_Title_Description" command for each result that it identifies
-- the search plugin will remove the "Result" command(s) each time it unloads - the unload is triggered by this plugin once the search plugin is detected as loaded
-- after each map is searched, this plugin will change the SearchParms command, repeating until all maps are searched

-- note, the "0" at the start of the command name is to avoid scanning all legit commands when looking for a parameter or result

	-- Map Data from MoorMap
searchWindow=Turbine.UI.Lotro.Window()
searchWindow:SetText("Search")
searchWindow:SetSize(600,400)
searchWindow:SetPosition((displayWidth-searchWindow:GetWidth())/2,(displayHeight-searchWindow:GetHeight())/2)
searchWindow:SetZOrder(3)
searchWindow.SearchLoaded=false

searchCaption=Turbine.UI.Label()
searchCaption:SetParent(searchWindow)
searchCaption:SetSize(100,20)
searchCaption:SetPosition(10,45)
searchCaption:SetText("Search:")
searchText=Turbine.UI.Lotro.TextBox()
searchText:SetParent(searchWindow)
searchText:SetSize(300,20)
searchText:SetPosition(110,45)
searchText:SetFont(Turbine.UI.Lotro.Font.Verdana16)
searchText:SetMultiline(false)
searchText.FocusGained=function()
	searchText:SetWantsKeyEvents(true)
end
searchText.FocusLost=function() searchText:SetWantsKeyEvents(false) end
searchText.KeyDown=function(sender,args)
	if args.Action==162 then
		searchText:SetWantsKeyEvents(false)
		cmdSearch:Focus()
		cmdSearch.Click()
	end
end

resultHeader1=Turbine.UI.Label()
resultHeader1:SetParent(searchWindow)
resultHeader1:SetSize(240,20)
resultHeader1:SetPosition(10,70)
resultHeader1:SetText("Name")

resultHeader2=Turbine.UI.Label()
resultHeader2:SetParent(searchWindow)
resultHeader2:SetSize(200,20)
resultHeader2:SetPosition(250,70)
resultHeader2:SetText("Map")

resultHeader3=Turbine.UI.Label()
resultHeader3:SetParent(searchWindow)
resultHeader3:SetSize(120,20)
resultHeader3:SetPosition(450,70)
resultHeader3:SetText("Coords")

resultList=Turbine.UI.ListBox()
resultList:SetParent(searchWindow)
resultList:SetSize(searchWindow:GetWidth()-30,searchWindow:GetHeight()-140)
resultList:SetPosition(10,90)
resultList:SetBackColor(Turbine.UI.Color.Black)

resultVScroll=Turbine.UI.Lotro.ScrollBar()
resultVScroll:SetParent(searchWindow)
resultVScroll:SetSize(10,resultList:GetHeight())
resultVScroll:SetPosition(resultList:GetWidth()+10,resultList:GetTop())
resultVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
resultList:SetVerticalScrollBar(resultVScroll)

noItems=Turbine.UI.Label()
noItems:SetParent(searchWindow)
noItems:SetZOrder(1)
noItems:SetSize(resultList:GetSize())
noItems:SetPosition(resultList:GetPosition())
noItems:SetText("No matching NPCs or locations")
noItems:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter)
noItems:SetVisible(false)

cmdSearch=Turbine.UI.Lotro.Button()
cmdSearch:SetParent(searchWindow)
cmdSearch:SetSize(100,20)
cmdSearch:SetPosition((searchWindow:GetWidth()-cmdSearch:GetWidth())/2,searchWindow:GetHeight()-45)
cmdSearch:SetText("Search")
cmdSearch.Click=function()
	local tmpText=searchText:GetText()
	if tmpText~="" then
		resultList:ClearItems()
		-- register the search parm command
		if searchCmd~=nil then
			Turbine.Shell.RemoveCommand(searchCmd); -- remove prior cmd
		else
			searchCmd=Turbine.ShellCommand()
		end
		searchWindow:SetWantsUpdates(true)
		Turbine.Shell.AddCommand("0TMP_"..string.lower(tmpText),searchCmd); -- this is automatically removed in the unload event handler
		Turbine.PluginManager.LoadPlugin("TMSearch");
		searchWindow.SearchLoaded=true
	end

end

searchWindow.Update=function()
	local cmds=Turbine.Shell.GetCommands();
	local done=false
	if Turbine.Shell.IsCommand("0TMC") then
		if cmds~=nil and type(cmds)=="table" then
			if cmds[0]~=nil then
				-- note, there is a bug that can cause GetCommands to return a 0 based array which won't always sort correctly
				table.insert(cmds,cmds[0])
				cmds[0]=nil
			end
			table.sort(cmds,function(arg1,arg2)if arg1<arg2 then return(true) end end);
		end
		searchWindow.results={}
		for cmdIndex=1,#cmds do
			if cmds[cmdIndex]>="1" then
				break
			else
				local result=string.match(cmds[cmdIndex],"0TMR_(.*)");

				if result~=nil then
					result=string.split(result,"_")
					result[2]=tonumber(result[2])
					result[3]=tonumber(result[3])
					result[4]=tonumber(result[4])
					result[7]=tonumber(result[7])
					if result[2]==nil then result[2]=1 end
					if result[3]==nil then result[3]=0 end
					if result[4]==nil then result[4]=0 end
					if result[5]==nil then result[5]="" end
					if result[6]==nil then result[6]="" end
					if result[7]==nil then result[7]=1 end
					if result[8]==nil then result[8]=result[5] end
					result[5]=string.gsub(result[5],"\194\184",",")
					result[8]=string.gsub(result[8],"\194\184",",")
					table.insert(searchWindow.results,{result[2],result[3],result[4],result[5],result[6],result[7],result[8]})
				end
			end
		end
		-- sort by region, name, ns, ew
		table.sort(searchWindow.results,function(arg1,arg2) if arg1[1]<arg2[1] then return true elseif arg1[1]==arg2[1] then if arg1[4]<arg2[4] then return true elseif arg1[4]==arg2[4] then if arg1[2]<arg2[2] then return true elseif arg1[2]==arg2[2] then if arg1[3]<arg2[3] then return true elseif arg1[3]==arg2[3] then if arg1[6]>arg2[6] then return true end end end end end end) -- sort on map then name then ns then ew
		-- now eliminate any duplicates
		local tmpIndex=2
		local max=#searchWindow.results
		while tmpIndex<=max do
			if searchWindow.results[tmpIndex][2]==searchWindow.results[tmpIndex-1][2] and searchWindow.results[tmpIndex][3]==searchWindow.results[tmpIndex-1][3] and searchWindow.results[tmpIndex][4]==searchWindow.results[tmpIndex-1][4] and searchWindow.results[tmpIndex][1]==searchWindow.results[tmpIndex-1][1] then
				-- same ns, ew, name and region
				table.remove(searchWindow.results,tmpIndex)
				max=max-1
			else
				tmpIndex=tmpIndex+1
			end
		end
		-- now re-sort by map, name, ns, ew
		table.sort(searchWindow.results,function(arg1,arg2) if arg1[5]<arg2[5] then return true elseif arg1[5]==arg2[5] then if arg1[4]<arg2[4] then return true elseif arg1[4]==arg2[4] then if arg1[2]<arg2[2] then return true elseif arg1[2]==arg2[2] then if arg1[3]<arg2[3] then return true end end end end end) -- sort on map then name then ns then ew

		for k,v in ipairs(searchWindow.results) do
			searchWindow.AddSearchResult(v[1],v[2],v[3],v[4],v[5],v[7])
		end
		noItems:SetVisible((#searchWindow.results==0))
		
		Turbine.PluginManager.UnloadScriptState("TMSearch");
		searchWindow.SearchLoaded=false
	end
end
searchWindow.AddSearchResult=function(region,ns,ew,name,map,description)
	local tmpItem=Turbine.UI.Control()
	tmpItem:SetParent(resultList)
	tmpItem:SetSize(resultList:GetWidth(),20)
	tmpItem.region=tonumber(region)
	tmpItem.ns=tonumber(ns)
	tmpItem.ew=tonumber(ew)
	tmpItem.name=name
	tmpItem.description=description

	tmpItem.tmpName=Turbine.UI.Label()
	tmpItem.tmpName:SetParent(tmpItem)
	tmpItem.tmpName:SetSize(240,20)
	tmpItem.tmpName:SetText(name)
	tmpItem.tmpName:SetMouseVisible(false)

	tmpItem.tmpMap=Turbine.UI.Label()
	tmpItem.tmpMap:SetParent(tmpItem)
	tmpItem.tmpMap:SetSize(200,20)
	tmpItem.tmpMap:SetLeft(240)
	tmpItem.tmpMap:SetText(map)
	tmpItem.tmpMap:SetMouseVisible(false)

	local tmpStr
	if tmpItem.ns<0 then
		tmpStr=tostring(0-tmpItem.ns).." S, "
	else
		tmpStr=tostring(tmpItem.ns).." N, "
	end
	if tmpItem.ew<0 then
		tmpStr=tmpStr..tostring(0-tmpItem.ew).." W"
	else
		tmpStr=tmpStr..tostring(tmpItem.ew).." E"
	end
	tmpItem.tmpCoords=Turbine.UI.Label()
	tmpItem.tmpCoords:SetParent(tmpItem)
	tmpItem.tmpCoords:SetSize(120,20)
	tmpItem.tmpCoords:SetLeft(440)
	tmpItem.tmpCoords:SetText(tmpStr)
	tmpItem.tmpCoords:SetSelectable(true)
--	tmpItem.tmpCoords:SetMouseVisible(false)

	tmpItem.MouseClick=function(sender,args)
		mapWindow.SetPing(sender.region,sender.ns,sender.ew)
	end
	resultList:AddItem(tmpItem)
end
