--***********************************************************************************************************************************
--                                                       share list window
-- this window displays and maintains the White List and Black List for sharing annotations
-- -- if a WhiteList entry is added, automatically process any entries from the pending annotations window
-- -- -- this is also called from the pending window if the user selects to whitelist any entries there
-- -- if a BlackList entry is added, automatically remove any matching entries from the pending annotations window
-- -- -- this is also called from the pending window if the user selects to blacklist any entries there
--***********************************************************************************************************************************
ShareListWindow=Turbine.UI.Lotro.Window()
ShareListWindow:SetSize(810,600)
ShareListWindow:SetPosition((displayWidth-ShareListWindow:GetWidth())/2,(displayHeight-ShareListWindow:GetHeight())/2)
ShareListWindow:SetText(Resource[language][90])

ShareListWindow.WhiteAll=Turbine.UI.Lotro.CheckBox()
ShareListWindow.WhiteAll:SetParent(ShareListWindow)
ShareListWindow.WhiteAll:SetText(Resource[language][99])
ShareListWindow.WhiteAll:SetSize(120,20)
ShareListWindow.WhiteAll:SetPosition(8,45)
ShareListWindow.WhiteAll.CheckedChanged=function()
	if not ShareListWindow.SettingAll then
		local isChecked=ShareListWindow.WhiteAll:IsChecked()
		for k=1,ShareListWindow.WhiteList:GetItemCount() do
			local tmpItem=ShareListWindow.WhiteList:GetItem(k)
			if tmpItem.IsSelected~=isChecked then
				tmpItem.Flip(tmpItem)
			end
		end
	end
end

ShareListWindow.WhiteCapt=Turbine.UI.Label()
ShareListWindow.WhiteCapt:SetParent(ShareListWindow)
ShareListWindow.WhiteCapt:SetPosition(ShareListWindow.WhiteAll:GetLeft()+ShareListWindow.WhiteAll:GetWidth(),45)
ShareListWindow.WhiteCapt:SetSize(ShareListWindow:GetWidth()/2-ShareListWindow.WhiteCapt:GetLeft(),20)
ShareListWindow.WhiteCapt:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
ShareListWindow.WhiteCapt:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.WhiteCapt:SetText(Resource[language][77])

ShareListWindow.BlackAll=Turbine.UI.Lotro.CheckBox()
ShareListWindow.BlackAll:SetParent(ShareListWindow)
ShareListWindow.BlackAll:SetText(Resource[language][99])
ShareListWindow.BlackAll:SetSize(120,20)
ShareListWindow.BlackAll:SetPosition(ShareListWindow:GetWidth()/2+10,45)
ShareListWindow.SettingAll=false
ShareListWindow.BlackAll.CheckedChanged=function()
	if not ShareListWindow.SettingAll then
		local isChecked=ShareListWindow.BlackAll:IsChecked()
		for k=1,ShareListWindow.BlackList:GetItemCount() do
			local tmpItem=ShareListWindow.BlackList:GetItem(k)
			if tmpItem.IsSelected~=isChecked then
				tmpItem.Flip(tmpItem)
			end
		end
	end
end

ShareListWindow.BlackCapt=Turbine.UI.Label()
ShareListWindow.BlackCapt:SetParent(ShareListWindow)
ShareListWindow.BlackCapt:SetPosition(ShareListWindow.BlackAll:GetLeft()+ShareListWindow.BlackAll:GetWidth(),45)
ShareListWindow.BlackCapt:SetSize(ShareListWindow:GetWidth()-ShareListWindow.BlackCapt:GetLeft(),20)
ShareListWindow.BlackCapt:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
ShareListWindow.BlackCapt:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.BlackCapt:SetText(Resource[language][78])
-- two lists, one white list, one black list
-- allow multi-select
-- put buttons for transfer between lists as well as one button for delete
-- the delete button will delete all selected entries from both lists

ShareListWindow.AddWhite=Turbine.UI.Lotro.Button()
ShareListWindow.AddWhite:SetParent(ShareListWindow)
ShareListWindow.AddWhite:SetSize(120,20)
ShareListWindow.AddWhite:SetPosition(ShareListWindow.WhiteAll:GetLeft(),ShareListWindow.WhiteCapt:GetTop()+ShareListWindow.WhiteCapt:GetHeight()+3)
ShareListWindow.AddWhite:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.AddWhite:SetText(Resource[language][91])
ShareListWindow.AddWhite.Click=function()
	if namePrompt~=nil then
		namePrompt:SetVisible(false)
		namePrompt=nil
	end
	namePrompt=InputPrompt(Resource[language][96],Resource[language][97],Turbine.UI.Lotro.Font.Verdana26,ShareListWindow.AddWhite.Callback)
	namePrompt:SetZOrder(ShareListWindow:GetZOrder()+1)
end
ShareListWindow.AddWhite.Callback=function()
	-- can not use the generic WhiteListAddNew because this doesn't work in silent mode
	local index=1
	name=namePrompt.Value
	-- verify that "name" is not already on the list
	local found=false
	for k,v in ipairs(WhiteList) do
		if v==name then
			found=true
			break
		end
	end
	if found then
		-- popup a message that the name is already on the list
		if mapWindow.PopUp~=nil then
			mapWindow.PopUp:SetVisible(false)
			mapWindow.PopUp=nil
		end
		mapWindow.PopUp=PopUpDialog("Duplicate Detected","The character:"..tostring(name).." is already on the White List for Shared Annotations.",4,"OK")
		mapWindow.PopUp:SetZOrder(PendingWindow:GetZOrder()+1)
	else
		-- verify that "name" is not already on the Black List - what do we do if it is?
		for k,v in ipairs(BlackList) do
			if v==name then
				ShareListWindow.removeIndex=k
				found=true
				break
			end
		end
		ShareListWindow.newName=name
		if found then
			-- popup a message that the name is already on the list
			if mapWindow.PopUp~=nil then
				mapWindow.PopUp:SetVisible(false)
				mapWindow.PopUp=nil
			end
			if language==2 then
				mapWindow.PopUp=PopUpDialog("Duplicate Detected","The name:"..tostring(name).." is on the Black List for Shared Annotations. Continuing will remove the name from the Black List and add it to the White List.",4,"OK","Cancel")
			elseif language==3 then
				mapWindow.PopUp=PopUpDialog("Duplicate Detected","The name:"..tostring(name).." is on the Black List for Shared Annotations. Continuing will remove the name from the Black List and add it to the White List.",4,"OK","Cancel")
			else
				mapWindow.PopUp=PopUpDialog("Duplicate Detected","The name:"..tostring(name).." is on the Black List for Shared Annotations. Continuing will remove the name from the Black List and add it to the White List.",4,"OK","Cancel")
			end
			mapWindow.PopUp:SetZOrder(PendingWindow:GetZOrder()+1)
			mapWindow.PopUp.Buttons[1].Click=function() local ret=WhiteListFinishAddNew(); if ret then PendingLaunchTMCust() end end
		else
			ShareListWindow.removeIndex=nil
			local ret=WhiteListFinishAddNew()
			if ret then PendingLaunchTMCust() end
		end
	end
end
PendingLaunchTMCust=function()
	-- detect if MoorMap is loaded and unload it
	local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
	for pluginIndex=1,#tmpPlugins do
		if tmpPlugins[pluginIndex].Name=="MoorMap" then
			mapWindow.ReloadMoorMap=true;
			break;
		end
	end
	if mapWindow.ReloadMoorMap then
		pcall(Turbine.PluginManager.UnloadScriptState,"MoorMap")
	end
	mapWindow.Pending:SetWantsUpdates(true)
	Turbine.PluginManager.LoadPlugin("TMCust")
end

ShareListWindow.RemoveWhite=Turbine.UI.Lotro.Button()
ShareListWindow.RemoveWhite:SetParent(ShareListWindow)
ShareListWindow.RemoveWhite:SetSize(120,20)
ShareListWindow.RemoveWhite:SetPosition(ShareListWindow.AddWhite:GetLeft()+ShareListWindow.AddWhite:GetWidth()+5,ShareListWindow.AddWhite:GetTop())
ShareListWindow.RemoveWhite:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.RemoveWhite:SetText(Resource[language][89])
ShareListWindow.RemoveWhite.Click=function(sender,args)
	local index=1
	while index<=ShareListWindow.WhiteList:GetItemCount() do
		local item=ShareListWindow.WhiteList:GetItem(index)
		if item.IsSelected then
			table.remove(WhiteList,index)
			ShareListWindow.WhiteList:RemoveItemAt(index)
		else
			index=index+1
		end
	end
end

ShareListWindow.MoveWhite=Turbine.UI.Lotro.Button()
ShareListWindow.MoveWhite:SetParent(ShareListWindow)
ShareListWindow.MoveWhite:SetSize(135,20)
ShareListWindow.MoveWhite:SetPosition(ShareListWindow.RemoveWhite:GetLeft()+ShareListWindow.RemoveWhite:GetWidth()+5,ShareListWindow.RemoveWhite:GetTop())
ShareListWindow.MoveWhite:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.MoveWhite:SetText(Resource[language][92])
ShareListWindow.MoveWhite.Click=function(sender,args)
	local index=1
	while index<=ShareListWindow.WhiteList:GetItemCount() do
		local item=ShareListWindow.WhiteList:GetItem(index)
		if item.IsSelected then
			item.IsSelected=false -- prevent accidental infinite loop in the bizare case of a duplicate name in source AND destination list (shouldn't be possible, but...)
			BlackListAddNew(item:GetText(),true)
		else
			index=index+1
		end
	end
end

ShareListWindow.GreenBorder=Turbine.UI.Control()
ShareListWindow.GreenBorder:SetParent(ShareListWindow)
ShareListWindow.GreenBorder:SetPosition(ShareListWindow.WhiteAll:GetLeft(),ShareListWindow.AddWhite:GetTop()+ShareListWindow.AddWhite:GetHeight()+3)
ShareListWindow.GreenBorder:SetSize(ShareListWindow:GetWidth()/2-ShareListWindow.GreenBorder:GetLeft()-10,ShareListWindow:GetHeight()-ShareListWindow.GreenBorder:GetTop()-35)
ShareListWindow.GreenBorder:SetBackColor(Turbine.UI.Color.DarkGreen)

ShareListWindow.WhiteList=Turbine.UI.ListBox()
ShareListWindow.WhiteList:SetParent(ShareListWindow.GreenBorder)
ShareListWindow.WhiteList:SetPosition(2,2)
ShareListWindow.WhiteList:SetSize(ShareListWindow.GreenBorder:GetWidth()-14,ShareListWindow.GreenBorder:GetHeight()-4)
ShareListWindow.WhiteList:SetBackColor(Turbine.UI.Color.White)

ShareListWindow.WhiteMask=Turbine.UI.Control()
ShareListWindow.WhiteMask:SetParent(ShareListWindow.GreenBorder)
ShareListWindow.WhiteMask:SetBackColor(Turbine.UI.Color.White)
ShareListWindow.WhiteMask:SetWidth(10)
ShareListWindow.WhiteMask:SetHeight(ShareListWindow.WhiteList:GetHeight())
ShareListWindow.WhiteMask:SetPosition(ShareListWindow.WhiteList:GetLeft()+ShareListWindow.WhiteList:GetWidth(),ShareListWindow.WhiteList:GetTop())

ShareListWindow.WhiteVScroll=Turbine.UI.Lotro.ScrollBar()
ShareListWindow.WhiteVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
ShareListWindow.WhiteVScroll:SetParent(ShareListWindow.GreenBorder)
ShareListWindow.WhiteVScroll:SetBackColor(Turbine.UI.Color.White)
ShareListWindow.WhiteVScroll:SetWidth(10)
ShareListWindow.WhiteVScroll:SetHeight(ShareListWindow.WhiteList:GetHeight())
ShareListWindow.WhiteVScroll:SetPosition(ShareListWindow.WhiteList:GetLeft()+ShareListWindow.WhiteList:GetWidth(),ShareListWindow.WhiteList:GetTop())
ShareListWindow.WhiteList:SetVerticalScrollBar(ShareListWindow.WhiteVScroll)

ShareListWindow.AddBlack=Turbine.UI.Lotro.Button()
ShareListWindow.AddBlack:SetParent(ShareListWindow)
ShareListWindow.AddBlack:SetSize(120,20)
ShareListWindow.AddBlack:SetPosition(ShareListWindow.BlackAll:GetLeft(),ShareListWindow.BlackCapt:GetTop()+ShareListWindow.BlackCapt:GetHeight()+3)
ShareListWindow.AddBlack:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.AddBlack:SetText(Resource[language][91])
ShareListWindow.AddBlack.Click=function()
	if namePrompt~=nil then
		namePrompt:SetVisible(false)
		namePrompt=nil
	end
	namePrompt=InputPrompt(Resource[language][96],Resource[language][98],Turbine.UI.Lotro.Font.Verdana26,function() BlackListAddNew(namePrompt.Value,false) end)
	namePrompt:SetZOrder(ShareListWindow:GetZOrder()+1)
end

ShareListWindow.RemoveBlack=Turbine.UI.Lotro.Button()
ShareListWindow.RemoveBlack:SetParent(ShareListWindow)
ShareListWindow.RemoveBlack:SetSize(120,20)
ShareListWindow.RemoveBlack:SetPosition(ShareListWindow.AddBlack:GetLeft()+ShareListWindow.AddBlack:GetWidth()+5,ShareListWindow.AddBlack:GetTop())
ShareListWindow.RemoveBlack:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.RemoveBlack:SetText(Resource[language][89])
ShareListWindow.RemoveBlack.Click=function(sender,args)
	local index=1
	while index<=ShareListWindow.BlackList:GetItemCount() do
		local item=ShareListWindow.BlackList:GetItem(index)
		if item.IsSelected then
			table.remove(BlackList,index)
			ShareListWindow.BlackList:RemoveItemAt(index)
		else
			index=index+1
		end
	end
end

ShareListWindow.MoveBlack=Turbine.UI.Lotro.Button()
ShareListWindow.MoveBlack:SetParent(ShareListWindow)
ShareListWindow.MoveBlack:SetSize(135,20)
ShareListWindow.MoveBlack:SetPosition(ShareListWindow.RemoveBlack:GetLeft()+ShareListWindow.RemoveBlack:GetWidth()+5,ShareListWindow.RemoveBlack:GetTop())
ShareListWindow.MoveBlack:SetFont(Turbine.UI.Lotro.Font.Verdana18)
ShareListWindow.MoveBlack:SetText(Resource[language][93])
ShareListWindow.MoveBlack.Click=function(sender,args)
	local index=1
	local launchTMCust=false
	while index<=ShareListWindow.BlackList:GetItemCount() do
		local item=ShareListWindow.BlackList:GetItem(index)
		if item.IsSelected then
			item.IsSelected=false -- prevent accidental infinite loop in the bizare case of a duplicate name in source AND destination list (shouldn't be possible, but...)
			launchTMCust=WhiteListAddNew(item:GetText())
		else
			index=index+1
		end
	end
	if launchTMCust then
		-- detect if MoorMap is loaded and unload it
		local tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
		for pluginIndex=1,#tmpPlugins do
			if tmpPlugins[pluginIndex].Name=="MoorMap" then
				mapWindow.ReloadMoorMap=true;
				break;
			end
		end
		if mapWindow.ReloadMoorMap then
			pcall(Turbine.PluginManager.UnloadScriptState,"MoorMap")
		end
		mapWindow.Pending:SetWantsUpdates(true)
		Turbine.PluginManager.LoadPlugin("TMCust")
	end
end

ShareListWindow.RedBorder=Turbine.UI.Control()
ShareListWindow.RedBorder:SetParent(ShareListWindow)
ShareListWindow.RedBorder:SetPosition(ShareListWindow.BlackAll:GetLeft(),ShareListWindow.AddBlack:GetTop()+ShareListWindow.AddBlack:GetHeight()+3)
ShareListWindow.RedBorder:SetSize(ShareListWindow.GreenBorder:GetSize())
ShareListWindow.RedBorder:SetBackColor(Turbine.UI.Color.Red)

ShareListWindow.BlackList=Turbine.UI.ListBox()
ShareListWindow.BlackList:SetParent(ShareListWindow.RedBorder)
ShareListWindow.BlackList:SetPosition(2,2)
ShareListWindow.BlackList:SetSize(ShareListWindow.RedBorder:GetWidth()-14,ShareListWindow.RedBorder:GetHeight()-4)
ShareListWindow.BlackList:SetBackColor(Turbine.UI.Color.Black)

ShareListWindow.BlackMask=Turbine.UI.Control()
ShareListWindow.BlackMask:SetParent(ShareListWindow.RedBorder)
ShareListWindow.BlackMask:SetBackColor(Turbine.UI.Color.Black)
ShareListWindow.BlackMask:SetWidth(10)
ShareListWindow.BlackMask:SetHeight(ShareListWindow.BlackList:GetHeight())
ShareListWindow.BlackMask:SetPosition(ShareListWindow.BlackList:GetLeft()+ShareListWindow.BlackList:GetWidth(),ShareListWindow.BlackList:GetTop())

ShareListWindow.BlackVScroll=Turbine.UI.Lotro.ScrollBar()
ShareListWindow.BlackVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
ShareListWindow.BlackVScroll:SetParent(ShareListWindow.RedBorder)
ShareListWindow.BlackVScroll:SetBackColor(Turbine.UI.Color.Black)
ShareListWindow.BlackVScroll:SetWidth(10)
ShareListWindow.BlackVScroll:SetHeight(ShareListWindow.BlackList:GetHeight())
ShareListWindow.BlackVScroll:SetPosition(ShareListWindow.BlackList:GetLeft()+ShareListWindow.BlackList:GetWidth(),ShareListWindow.BlackList:GetTop())
ShareListWindow.BlackList:SetVerticalScrollBar(ShareListWindow.BlackVScroll)

--ShareListWindow.LightToDark=Turbine.UI.Label()
--ShareListWindow.LightToDark:SetParent(ShareListWindow)
--ShareListWindow.LightToDark:SetSize(26,20)
--ShareListWindow.LightToDark:SetPosition((ShareListWindow:GetWidth()-ShareListWindow.LightToDark:GetWidth())/2,ShareListWindow.GreenBorder:GetTop()+ShareListWindow.GreenBorder:GetHeight()/2-50)
--ShareListWindow.LightToDark:SetBackground(resourcePath.."MoveRight.jpg")

--ShareListWindow.Delete=Turbine.UI.Label()
--ShareListWindow.Delete:SetParent(ShareListWindow)
--ShareListWindow.Delete:SetSize(26,20)
--ShareListWindow.Delete:SetPosition((ShareListWindow:GetWidth()-ShareListWindow.Delete:GetWidth())/2,ShareListWindow.LightToDark:GetTop()+ShareListWindow.LightToDark:GetHeight()+20)
--ShareListWindow.Delete:SetBackground(resourcePath.."Delete.jpg")

--ShareListWindow.DarkToLight=Turbine.UI.Label()
--ShareListWindow.DarkToLight:SetParent(ShareListWindow)
--ShareListWindow.DarkToLight:SetSize(26,20)
--ShareListWindow.DarkToLight:SetPosition((ShareListWindow:GetWidth()-ShareListWindow.DarkToLight:GetWidth())/2,ShareListWindow.Delete:GetTop()+ShareListWindow.Delete:GetHeight()+20)
--ShareListWindow.DarkToLight:SetBackground(resourcePath.."MoveLeft.jpg")

ShareListWindow.RefreshLists=function()
	-- clear then fill the lists from the underlying tables
	ShareListWindow.WhiteList:ClearItems()
	ShareListWindow.BlackList:ClearItems()
	table.sort(WhiteList) -- presort the list
	table.sort(BlackList) -- presort the list
	for k,v in ipairs(WhiteList) do
		-- create a new row in the list
		local tmpRow=Turbine.UI.Label()
		tmpRow:SetParent(ShareWindow.WhiteList)
		tmpRow:SetBackColor(Turbine.UI.Color.White)
		tmpRow:SetForeColor(Turbine.UI.Color.DarkGreen)
		tmpRow:SetWidth(ShareListWindow.WhiteList:GetWidth())
		tmpRow:SetHeight(22)
		tmpRow:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
		tmpRow:SetText(v)
		tmpRow.IsSelected=false
		tmpRow.MouseClick=function(sender)
			ShareListWindow.SettingAll=true
			ShareListWindow.WhiteAll:SetChecked(false)
			ShareListWindow.SettingAll=false
			sender.Flip(sender)
		end
		tmpRow.Flip=function(sender)
			sender.IsSelected=not sender.IsSelected
			if sender.IsSelected then
				tmpRow:SetBackColor(Turbine.UI.Color.DarkGreen)
				tmpRow:SetForeColor(Turbine.UI.Color.White)
			else
				tmpRow:SetBackColor(Turbine.UI.Color.White)
				tmpRow:SetForeColor(Turbine.UI.Color.DarkGreen)
			end
		end
		ShareListWindow.WhiteList:AddItem(tmpRow)
	end
	for k,v in ipairs(BlackList) do
		-- create a new row in the list
		local tmpRow=Turbine.UI.Label()
		tmpRow:SetParent(ShareWindow.BlackList)
		tmpRow:SetBackColor(Turbine.UI.Color.Black)
		tmpRow:SetForeColor(Turbine.UI.Color(1,.4,.4))
		tmpRow:SetWidth(ShareListWindow.BlackList:GetWidth())
		tmpRow:SetHeight(22)
		tmpRow:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
		tmpRow:SetText(v)
		tmpRow.IsSelected=false
		tmpRow.MouseClick=function(sender)
			ShareListWindow.SettingAll=true
			ShareListWindow.BlackAll:SetChecked(false)
			ShareListWindow.SettingAll=false
			sender.Flip(sender)
		end
		tmpRow.Flip=function(sender)
			sender.IsSelected=not sender.IsSelected
			if sender.IsSelected then
				tmpRow:SetBackColor(Turbine.UI.Color.Red)
				tmpRow:SetForeColor(Turbine.UI.Color.Black)
			else
				tmpRow:SetBackColor(Turbine.UI.Color.Black)
				tmpRow:SetForeColor(Turbine.UI.Color(1,.4,.4))
			end
		end
		ShareListWindow.BlackList:AddItem(tmpRow)
	end
end
WhiteListAddNew=function(name)
	local retVal=false
	-- no notices, just process
	-- verify that "name" is not already on the list
	local found=false
	for k,v in ipairs(WhiteList) do
		if v==name then
			found=true
			break
		end
	end
	if not found then
		-- verify that "name" is not already on the Black List - what do we do if it is?
		ShareListWindow.removeIndex=nil
		for k,v in ipairs(BlackList) do
			if v==name then
				ShareListWindow.removeIndex=k
				found=true
				break
			end
		end
		ShareListWindow.newName=name
		retVal=WhiteListFinishAddNew()
	end
	return retVal
end
WhiteListFinishAddNew=function()
	local retVal=false
	if mapWindow.PopUp~=nil then
		mapWindow.PopUp:SetVisible(false)
	end
	local name=ShareListWindow.newName
	local newIndex
	-- find position in list for name alphabetically (find index of first name that is greater than the new name)
	for k,v in ipairs(WhiteList) do
		if v>name then
			newIndex=k
			break
		end
	end
	if newIndex~=nil then
		table.insert(WhiteList,newIndex,name)
	else
		-- add to end of list
		table.insert(WhiteList,name)
	end
	if ShareListWindow.removeIndex~=nil then
		table.remove(BlackList,ShareListWindow.removeIndex)
	end
	if ShareListWindow:IsVisible() then
		local tmpRow=Turbine.UI.Label()
		tmpRow:SetParent(ShareWindow.WhiteList)
		tmpRow:SetBackColor(Turbine.UI.Color.White)
		tmpRow:SetForeColor(Turbine.UI.Color.DarkGreen)
		tmpRow:SetWidth(ShareListWindow.WhiteList:GetWidth())
		tmpRow:SetHeight(22)
		tmpRow:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
		tmpRow:SetText(name)
		tmpRow.IsSelected=false
		tmpRow.MouseClick=function(sender)
			sender.IsSelected=not sender.IsSelected
			if sender.IsSelected then
				tmpRow:SetBackColor(Turbine.UI.Color.DarkGreen)
				tmpRow:SetForeColor(Turbine.UI.Color.White)
			else
				tmpRow:SetBackColor(Turbine.UI.Color.White)
				tmpRow:SetForeColor(Turbine.UI.Color.DarkGreen)
			end
		end
		if newIndex~=nil then
			ShareListWindow.WhiteList:InsertItem(newIndex,tmpRow)
		else
			-- add to end of list
			ShareListWindow.WhiteList:AddItem(tmpRow)
		end
		if ShareListWindow.removeIndex~=nil then
			ShareListWindow.BlackList:RemoveItemAt(ShareListWindow.removeIndex)
		end
	end
	-- process all entries with source=name
	local index=1
	while index<=PendingWindow.List:GetItemCount() do
		local item=PendingWindow.List:GetItem(index)
		if item.Source:GetText()==name then
			retVal=true
			mapWindow.AddBatchAnnotation(item.region, item.ns, item.ew, item.type, item.Name:GetText(), item.Desc:GetText())
			PendingWindow.List:RemoveItemAt(index)
		else
			index=index+1
		end
	end
	return retVal
end
BlackListAddNew=function(name,auto)
	if auto==nil then auto=false end
	-- verify that "name" is not already on the list
	local found=false
	for k,v in ipairs(BlackList) do
		if v==name then
			found=true
			break
		end
	end
	if found then
		if not auto then
			-- popup a message that the name is already on the list
			if mapWindow.PopUp~=nil then
				mapWindow.PopUp:SetVisible(false)
				mapWindow.PopUp=nil
			end
			mapWindow.PopUp=PopUpDialog("Duplicate Detected","The name:"..tostring(name).." is already on the Black List for Shared Annotations.",4,"OK")
			mapWindow.PopUp:SetZOrder(PendingWindow:GetZOrder()+1)
		end
	else
		-- verify that "name" is not already on the White list - what do we do if it is?
		for k,v in ipairs(WhiteList) do
			if v==name then
				ShareListWindow.removeIndex=k
				found=true
				break
			end
		end
		local continue=true
		ShareListWindow.newName=name
		if found then
			if auto then
				BlackListFinishAddNew()
			else
				-- popup a message that the name is already on the list
				if mapWindow.PopUp~=nil then
					mapWindow.PopUp:SetVisible(false)
					mapWindow.PopUp=nil
				end
				if language==2 then
					mapWindow.PopUp=PopUpDialog("Duplicate Detected","The name:"..tostring(name).." is on the White List for Shared Annotations. Continuing will remove the name from the White List and add it to the Black List.",4,"OK","Cancel")
				elseif language==3 then
					mapWindow.PopUp=PopUpDialog("Duplicate Detected","The name:"..tostring(name).." is on the White List for Shared Annotations. Continuing will remove the name from the White List and add it to the Black List.",4,"OK","Cancel")
				else
					mapWindow.PopUp=PopUpDialog("Duplicate Detected","The name:"..tostring(name).." is on the White List for Shared Annotations. Continuing will remove the name from the White List and add it to the Black List.",4,"OK","Cancel")
				end
				mapWindow.PopUp:SetZOrder(PendingWindow:GetZOrder()+1)
				mapWindow.PopUp.Buttons[1].Click=BlackListFinishAddNew
			end
		else
			ShareListWindow.removeIndex=nil
			BlackListFinishAddNew()
		end
	end
end
BlackListFinishAddNew=function()
	if mapWindow.PopUp~=nil then
		mapWindow.PopUp:SetVisible(false)
	end
	local name=ShareListWindow.newName
	local newIndex
	for k,v in ipairs(BlackList) do
		if v>name then
			newIndex=k
			break
		end
	end
	if newIndex~=nil then
		table.insert(BlackList,newIndex,name)
	else
		-- add to end of list
		table.insert(BlackList,name)
	end
	if ShareListWindow.removeIndex~=nil then
		-- the name was previously on the White list, remove it
		table.remove(WhiteList,ShareListWindow.removeIndex)
	end
	if ShareListWindow:IsVisible() then
		local tmpRow=Turbine.UI.Label()
		tmpRow:SetParent(ShareWindow.BlackList)
		tmpRow:SetBackColor(Turbine.UI.Color.Black)
		tmpRow:SetForeColor(Turbine.UI.Color(1,.4,.4))
		tmpRow:SetWidth(ShareListWindow.BlackList:GetWidth())
		tmpRow:SetHeight(22)
		tmpRow:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
		tmpRow:SetText(name)
		tmpRow.IsSelected=false
		tmpRow.MouseClick=function(sender)
			sender.IsSelected=not sender.IsSelected
			if sender.IsSelected then
				tmpRow:SetBackColor(Turbine.UI.Color.Red)
				tmpRow:SetForeColor(Turbine.UI.Color.Black)
			else
				tmpRow:SetBackColor(Turbine.UI.Color.Black)
				tmpRow:SetForeColor(Turbine.UI.Color(1,.4,.4))
			end
		end
		if newIndex~=nil then
			ShareListWindow.BlackList:InsertItem(newIndex,tmpRow)
		else
			ShareListWindow.BlackList:AddItem(tmpRow)
		end
		if ShareListWindow.removeIndex~=nil then
			ShareListWindow.WhiteList:RemoveItemAt(ShareListWindow.removeIndex)
		end
	end
	-- remove all entries with source=name
	local index=1
	while index<=PendingWindow.List:GetItemCount() do
		local item=PendingWindow.List:GetItem(index)
		if item.Source:GetText()==name then
			PendingWindow.List:RemoveItemAt(index)
		else
			index=index+1
		end
	end
end
-- todo: create functions ShareListWindow.WhiteList.AddNew(name), ShareListWindow.BlackList.AddNew(name)
-- --    create functions ShareListWindow.WhiteList.Remove(name), ShareListWindow.BlackList.Remove(name)
-- --    create functions ShareListWindow.WhiteList.Contains(name) - returns true if there is an entry matching the name, false otherwise
-- --    create functions ShareListWindow.BlackList.Contains(name) - returns true if there is an entry matching the name, false otherwise
